install RO from source: fix to properly install ovim lib
[osm/RO.git] / scripts / install-openmano.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5 # This file is part of openmano
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
25 #Get needed packages, source code and configure to run openmano
26 #Ask for database user and password if not provided
27
28 function usage(){
29 echo -e "usage: sudo -E $0 [OPTIONS]"
30 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
32 echo -e " OPTIONS"
33 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
35 echo -e " -q --quiet: install in unattended mode"
36 echo -e " -h --help: show this help"
37 echo -e " -b REFSPEC: install from source code using a specific branch (master, v2.0, ...) or tag"
38 echo -e " -b master (main RO branch)"
39 echo -e " -b v2.0 (v2.0 branch)"
40 echo -e " -b tags/v1.1.0 (a specific tag)"
41 echo -e " ..."
42 echo -e " --develop: install last version for developers, and do not configure as a service"
43 echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one"
44 echo -e " --updatedb: do not reinstall mano_db DB if it exists, just update database"
45 echo -e " --force: makes idenpotent, delete previous installations folders if needed. It assumes --updatedb if --forcedb option is not provided"
46 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
47 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
48 echo -e " --no-db: do not install mysql server"
49 }
50
51 function install_packages(){
52 [ -x /usr/bin/apt-get ] && apt-get install -y $*
53 [ -x /usr/bin/yum ] && yum install -y $*
54
55 #check properly installed
56 for PACKAGE in $*
57 do
58 PACKAGE_INSTALLED="no"
59 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
60 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
61 if [ "$PACKAGE_INSTALLED" = "no" ]
62 then
63 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
64 exit 1
65 fi
66 done
67 }
68
69 function ask_user(){
70 # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive
71 # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed
72 # Return: true(0) if user type 'yes'; false (1) if user type 'no'
73 read -e -p "$1" USER_CONFIRMATION
74 while true ; do
75 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0
76 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1
77 [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0
78 [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1
79 read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION
80 done
81 }
82
83 GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
84 GIT_OVIM_URL=https://osm.etsi.org/gerrit/osm/openvim.git
85 GIT_OSMIM_URL=https://osm.etsi.org/gerrit/osm/IM.git
86 DBUSER="root"
87 DBPASSWD=""
88 DBPASSWD_PARAM=""
89 QUIET_MODE=""
90 DEVELOP=""
91 DB_FORCE_UPDATE=""
92 UPDATEDB=""
93 FORCE=""
94 NOCLONE=""
95 NO_PACKAGES=""
96 NO_DB=""
97 COMMIT_ID=""
98
99 while getopts ":u:p:b:hiq-:" o; do
100 case "${o}" in
101 u)
102 export DBUSER="$OPTARG"
103 ;;
104 p)
105 export DBPASSWD="$OPTARG"
106 export DBPASSWD_PARAM="-p$OPTARG"
107 ;;
108 b)
109 export COMMIT_ID=${OPTARG}
110 ;;
111 q)
112 export QUIET_MODE=yes
113 export DEBIAN_FRONTEND=noninteractive
114 ;;
115 h)
116 usage && exit 0
117 ;;
118 -)
119 [ "${OPTARG}" == "help" ] && usage && exit 0
120 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
121 [ "${OPTARG}" == "forcedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--forcedb" && continue
122 [ "${OPTARG}" == "updatedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--updatedb" && continue
123 [ "${OPTARG}" == "force" ] && FORCE="y" && continue
124 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
125 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
126 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
127 [ "${OPTARG}" == "no-db" ] && NO_DB="y" && continue
128 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
129 exit 1
130 ;;
131 \?)
132 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
133 exit 1
134 ;;
135 :)
136 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
137 exit 1
138 ;;
139 *)
140 usage >&2
141 exit 1
142 ;;
143 esac
144 done
145
146 if [ "$DB_FORCE_UPDATE" == "--forcedb--updatedb" ] || [ "$DB_FORCE_UPDATE" == "--updatedb--forcedb" ] ; then
147 echo "Error: options --forcedb and --updatedb are mutually exclusive" >&2
148 exit 1
149 elif [ -n "$FORCE" ] && [ -z "$DB_FORCE_UPDATE" ] ; then
150 DB_FORCE_UPDATE="--updatedb"
151 fi
152
153 #check root privileges and non a root user behind
154 [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
155 if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
156 then
157 [[ -z $QUIET_MODE ]] && ! ask_user "Install in the root user (y/N)? " n && echo "Cancelled" && exit 1
158 export SUDO_USER=root
159 fi
160
161 # Discover Linux distribution
162 # try redhat type
163 [ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
164 # if not assuming ubuntu type
165 [ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
166 if [ "$_DISTRO" == "Ubuntu" ]
167 then
168 _RELEASE=$(lsb_release -rs)
169 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
170 then
171 [[ -z $QUIET_MODE ]] &&
172 ! ask_user "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)' (y/N)? " n &&
173 echo "Cancelled" && exit 1
174 _RELEASE = 14
175 fi
176 elif [ "$_DISTRO" == "CentOS" ]
177 then
178 _RELEASE="7"
179 if ! cat /etc/redhat-release | grep -q "7."
180 then
181 [[ -z $QUIET_MODE ]] &&
182 ! ask_user "WARNING! Not tested CentOS version. Continue assuming a '$_RELEASE' type (y/N)? " n &&
183 echo "Cancelled" && exit 1
184 fi
185 elif [ "$_DISTRO" == "Red" ]
186 then
187 _RELEASE="7"
188 if ! cat /etc/redhat-release | grep -q "7."
189 then
190 [[ -z $QUIET_MODE ]] &&
191 ! ask_user "WARNING! Not tested Red Hat OS version. Continue assuming a '$_RELEASE' type (y/N)? " n &&
192 echo "Cancelled" && exit 1
193 fi
194 else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
195 _DISTRO_DISCOVER=$_DISTRO
196 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
197 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
198 [[ -z $QUIET_MODE ]] &&
199 ! ask_user "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type (y/N)? " n &&
200 echo "Cancelled" && exit 1
201 fi
202
203 #check if installed as a service
204 INSTALL_AS_A_SERVICE=""
205 [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y"
206
207 # Next operations require knowing BASEFOLDER
208 if [[ -z "$NOCLONE" ]]; then
209 if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then
210 BASEFOLDER=__openmano__${RANDOM}
211 else
212 BASEFOLDER="${PWD}/openmano"
213 fi
214 [[ -n "$FORCE" ]] && rm -rf $BASEFOLDER #make idempotent
215 else
216 HERE=$(dirname $(readlink -f ${BASH_SOURCE[0]}))
217 BASEFOLDER=$(dirname $HERE)
218 fi
219
220 if [[ -z "$NO_PACKAGES" ]]
221 then
222 echo -e "\n"\
223 "#################################################################\n"\
224 "##### UPDATE REPOSITORIES #####\n"\
225 "#################################################################"
226 [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
227
228 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
229 [ "$_DISTRO" == "CentOS" ] && yum install -y epel-release
230 [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
231 && rpm -ivh epel-release-7-5.noarch.rpm && yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
232 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum repolist
233
234 echo -e "\n"\
235 "#################################################################\n"\
236 "##### INSTALL REQUIRED PACKAGES #####\n"\
237 "#################################################################"
238 [ "$_DISTRO" == "Ubuntu" ] && install_packages "git make screen wget mysql-client"
239 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git make screen wget mariadb-client"
240
241 echo -e "\n"\
242 "#################################################################\n"\
243 "##### INSTALL PYTHON PACKAGES #####\n"\
244 "#################################################################"
245 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip python-crypto"
246 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip python-crypto"
247 # The only way to install python-bottle on Centos7 is with easy_install or pip
248 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
249
250 # required for vmware connector TODO move that to separete opt in install script
251 pip install --upgrade pip || exit 1
252 pip install pyvcloud || exit 1
253 pip install progressbar || exit 1
254 pip install prettytable || exit 1
255 pip install pyvmomi || exit 1
256
257 # required for AWS connector
258 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-boto"
259 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-boto" #TODO check if at Centos it exists with this name, or PIP should be used
260
261 # install openstack client needed for using openstack as a VIM
262 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient "\
263 "python-neutronclient python-cinderclient python-openstackclient"
264 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install \
265 python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient \
266 python-openstackclient #TODO revise if gcc python-pip is needed
267 fi # [[ -z "$NO_PACKAGES" ]]
268
269 if [[ -z $NOCLONE ]]; then
270 echo -e "\n"\
271 "#################################################################\n"\
272 "##### DOWNLOAD SOURCE #####\n"\
273 "#################################################################"
274 if [[ -d "${BASEFOLDER}" ]] ; then
275 if [[ -n "$FORCE" ]] ; then
276 echo "deleting '${BASEFOLDER}' folder"
277 rm -rf "$BASEFOLDER" #make idempotent
278 elif [[ -z "$QUIET_MODE" ]] ; then
279 ! ask_user "folder '${BASEFOLDER}' exists, overwrite (y/N)? " n && echo "Cancelled!" && exit 1
280 rm -rf "$BASEFOLDER"
281 else
282 echo "'${BASEFOLDER}' folder exists. Use "--force" to overwrite" >&2 && exit 1
283 fi
284 fi
285 su $SUDO_USER -c "git clone ${GIT_URL} ${BASEFOLDER}" || ! echo "Error cannot clone from '$GIT_URL'" >&2 || exit 1
286 if [[ -n $COMMIT_ID ]] ; then
287 echo -e "Installing osm-RO from refspec: $COMMIT_ID"
288 su $SUDO_USER -c "git -C ${BASEFOLDER} checkout $COMMIT_ID" ||
289 ! echo "Error cannot checkout '$COMMIT_ID' from '$GIT_URL'" >&2 || exit 1
290 elif [[ -z $DEVELOP ]]; then
291 LATEST_STABLE_TAG=`git -C "${BASEFOLDER}" tag -l "v[0-9]*" | sort -V | tail -n1`
292 echo -e "Installing osm-RO from refspec: tags/${LATEST_STABLE_TAG}"
293 su $SUDO_USER -c "git -C ${BASEFOLDER} checkout tags/${LATEST_STABLE_TAG}" ||
294 ! echo "Error cannot checkout 'tags/${LATEST_STABLE_TAG}' from '$GIT_URL'" >&2 || exit 1
295 else
296 echo -e "Installing osm-RO from refspec: master"
297 fi
298 su $SUDO_USER -c "cp ${BASEFOLDER}/.gitignore-common ${BASEFOLDER}/.gitignore"
299 fi
300
301 echo -e "\n"\
302 "#################################################################\n"\
303 "##### INSTALLING OSM-IM LIBRARY #####\n"\
304 "#################################################################"
305 su $SUDO_USER -c "git -C ${BASEFOLDER} clone ${GIT_OSMIM_URL} IM" ||
306 ! echo "Error cannot clone from '${GIT_OSMIM_URL}'" >&2 || exit 1
307 if [[ -n $COMMIT_ID ]] ; then
308 echo -e "Installing osm-IM from refspec: $COMMIT_ID"
309 su $SUDO_USER -c "git -C ${BASEFOLDER}/IM checkout $COMMIT_ID" ||
310 ! echo "Error cannot checkout '$COMMIT_ID' from '${GIT_OSMIM_URL}'" >&2 || exit 1
311 elif [[ -z $DEVELOP ]]; then
312 LATEST_STABLE_TAG=`git -C "${BASEFOLDER}/IM" tag -l "v[0-9]*" | sort -V | tail -n1`
313 echo -e "Installing osm-IM from refspec: tags/${LATEST_STABLE_TAG}"
314 su $SUDO_USER -c "git -C ${BASEFOLDER}/IM checkout tags/${LATEST_STABLE_TAG}" ||
315 ! echo "Error cannot checkout 'tags/${LATEST_STABLE_TAG}' from '${GIT_OSMIM_URL}'" >&2 || exit 1
316 else
317 echo -e "Installing osm-IM from refspec: master"
318 fi
319
320 # Install debian dependencies before setup.py
321 if [[ -z "$NO_PACKAGES" ]]
322 then
323 [ "$_DISTRO" == "Ubuntu" ] && install_packages "tox debhelper python-bitarray python-lxml python-six"
324 # TODO check packages for CentOS and RedHat
325 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "tox debhelper python-bitarray python-lxml python-six"
326 pip install --upgrade stdeb pyangbind || exit 1
327 fi
328 su $SUDO_USER -c "make -C ${BASEFOLDER}/IM all"
329 dpkg -i ${BASEFOLDER}/IM/deb_dist/python-osm-im*.deb ${BASEFOLDER}/IM/pyangbind/deb_dist/*.deb \
330 ${BASEFOLDER}/IM/pyang/deb_dist/*.deb
331 rm -rf "${BASEFOLDER}/IM"
332 OSM_IM_PATH=`python -c 'import osm_im; print osm_im.__path__[0]'` ||
333 ! echo "ERROR installing python-osm-im library!!!" >&2 || exit 1
334
335
336 echo -e "\n"\
337 "#################################################################\n"\
338 "##### INSTALLING OVIM LIBRARY #####\n"\
339 "#################################################################"
340 su $SUDO_USER -c "git -C ${BASEFOLDER} clone ${GIT_OVIM_URL} openvim" ||
341 ! echo "Error cannot clone from '${GIT_OVIM_URL}'" || exit 1
342 if [[ -n $COMMIT_ID ]] ; then
343 echo -e "Installing lib_osm_openvim from refspec: $COMMIT_ID"
344 su $SUDO_USER -c "git -C ${BASEFOLDER}/openvim checkout $COMMIT_ID" ||
345 ! echo "Error cannot checkout '$COMMIT_ID' from '${GIT_OVIM_URL}'" || exit 1
346 elif [[ -z $DEVELOP ]]; then
347 LATEST_STABLE_TAG=`git -C "${BASEFOLDER}/openvim" tag -l "v[0-9]*" | sort -V | tail -n1`
348 echo -e "Installing lib_osm_openvim from refspec: tags/${LATEST_STABLE_TAG}"
349 su $SUDO_USER -c "git -C ${BASEFOLDER}/openvim checkout tags/${LATEST_STABLE_TAG}" ||
350 ! echo "Error cannot checkout 'tags/${LATEST_STABLE_TAG}' from '${GIT_OVIM_URL}'" || exit 1
351 else
352 echo -e "Installing lib_osm_openvim from refspec: master"
353 fi
354
355 # Install debian dependencies before setup.py
356 if [[ -z "$NO_PACKAGES" ]]
357 then
358 [ "$_DISTRO" == "Ubuntu" ] && install_packages \
359 "libmysqlclient-dev python-cffi python-packaging python-pkgconfig python-pycparser libssl-dev libffi-dev"
360 # TODO check if that is the name in CentOS and RedHat
361 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages \
362 "libmysqlclient-dev python-cffi python-packaging python-pkgconfig python-pycparser libssl-dev libffi-dev"
363 pip install --upgrade stdeb setuptools-version-command || exit 1
364 fi
365 su $SUDO_USER -c "make -C ${BASEFOLDER}/openvim lite"
366 dpkg -i ${BASEFOLDER}/openvim/.build/python-lib-osm-openvim*.deb
367 rm -rf "${BASEFOLDER}/openvim"
368 OSMLIBOVIM_PATH=`python -c 'import lib_osm_openvim; print lib_osm_openvim.__path__[0]'` ||
369 ! echo "ERROR installing python-lib-osm-openvim library!!!" >&2 || exit 1
370
371 if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
372 then
373 echo -e "\n"\
374 "#################################################################\n"\
375 "##### CONFIGURE firewalld #####\n"\
376 "#################################################################"
377 if [[ -z $QUIET_MODE ]] || ask_user "Configure firewalld for openmanod port 9090 (Y/n)? " y
378 then
379 #Creates a service file for openmano
380 echo '<?xml version="1.0" encoding="utf-8"?>
381 <service>
382 <short>openmanod</short>
383 <description>openmanod service</description>
384 <port protocol="tcp" port="9090"/>
385 </service>' > /etc/firewalld/services/openmanod.xml
386 #put proper permissions
387 pushd /etc/firewalld/services > /dev/null
388 restorecon openmanod.xml
389 chmod 640 openmanod.xml
390 popd > /dev/null
391 #Add the openmanod service to the default zone permanently and reload the firewall configuration
392 firewall-cmd --permanent --add-service=openmanod > /dev/null
393 firewall-cmd --reload > /dev/null
394 echo "done."
395 else
396 echo "skipping."
397 fi
398 fi
399
400 echo -e "\n"\
401 "#################################################################\n"\
402 "##### CONFIGURE OPENMANO CLIENT #####\n"\
403 "#################################################################"
404 #creates a link at ~/bin if not configured as a service
405 if [[ -z "$INSTALL_AS_A_SERVICE" ]]
406 then
407 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
408 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
409 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
410 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
411 su $SUDO_USER -c "ln -s '${BASEFOLDER}/openmano' "'${HOME}/bin/openmano'
412 su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report'
413 su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/service-openmano' "'${HOME}/bin/service-openmano'
414
415 #insert /home/<user>/bin in the PATH
416 #skiped because normally this is done authomatically when ~/bin exists
417 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
418 #then
419 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
420 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
421 #fi
422
423 if [[ $SUDO_USER == root ]]
424 then
425 if ! echo $PATH | grep -q "${HOME}/bin"
426 then
427 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
428 fi
429 fi
430 fi
431
432 #configure arg-autocomplete for this user
433 #in case of minimal instalation this package is not installed by default
434 [[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
435 #su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
436 su $SUDO_USER -c 'activate-global-python-argcomplete --user'
437 if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
438 then
439 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
440 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
441 fi
442
443 if [ -z "$NO_DB" ]; then
444 echo -e "\n"\
445 "#################################################################\n"\
446 "##### INSTALL DATABASE SERVER #####\n"\
447 "#################################################################"
448
449 if [ -n "$QUIET_MODE" ]; then
450 DB_QUIET='-q'
451 fi
452 ${BASEFOLDER}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} $DB_QUIET $DB_FORCE_UPDATE || exit 1
453 echo -e "\n"\
454 "#################################################################\n"\
455 "##### CREATE AND INIT MANO_VIM DATABASE #####\n"\
456 "#################################################################"
457 # Install mano_vim_db after setup
458 ${OSMLIBOVIM_PATH}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} -u mano -p manopw -d mano_vim_db --no-install-packages $DB_QUIET $DB_FORCE_UPDATE || exit 1
459 fi # [ -z "$NO_DB" ]
460
461 if [[ -n "$INSTALL_AS_A_SERVICE" ]]
462 then
463 echo -e "\n"\
464 "#################################################################\n"\
465 "##### CONFIGURE OPENMANO SERVICE #####\n"\
466 "#################################################################"
467
468 ${BASEFOLDER}/scripts/install-openmano-service.sh -f ${BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"`
469 # rm -rf ${BASEFOLDER}
470 # alias service-openmano="service openmano"
471 # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
472 echo
473 echo "Done! installed at /opt/openmano"
474 echo " Manage server with 'sudo -E service osm-ro start|stop|status|...' "
475 else
476 echo
477 echo "Done! you may need to logout and login again for loading client configuration"
478 echo " Run './${BASEFOLDER}/scripts/service-openmano start' for starting openmano in a screen"
479 fi